public static class EMCCVAspect extends EMCCVMenuElement {
  public static int WIDTH = 280;

  public int probability = 75;
  public boolean visible = false;
  public String style;
  public boolean alwayson = false;
  public boolean randomizecolor = true;
  public Map<String, EMCCVStylegroup> stylegroups = new LinkedHashMap<String, EMCCVStylegroup>();
  
  public boolean colorchain = false;

  @Override
  public boolean isActive() {
    if (logging && logInfo) log.append(getTime() + "[DRAW][IS ACTIVE][ASPECT] id - " + this.id + "\n");
    
    if (this.disabled || (!this.visible && !this.alwayson)) return false;
    
    if (this.checked == 0) {
      boolean bResult = true;

      if (!alwayson) {
        EMCCVMenuElement xmlParent = this.getXMLParent();
        if (xmlParent != null) {
          if (logging && logInfo) log.append(getTime() + "[DRAW][IS ACTIVE][ASPECT] xmlParent.id - " + xmlParent.id + "\n");
          bResult = xmlParent.isActive();
        }
      } else if (logging && logInfo) {
        log.append(getTime() + "[DRAW][IS ACTIVE][ASPECT] " + this.id + " is ALWAYSON.\n");
      }

      if (bResult && this.parent != null && !this.parent.equals("")) {      
        bResult = bResult && checkParents(this.parent);
      }

      if (bResult) {
        checked = 1; // visible
      } else {
        checked = -1; // not visible
      }
    }
    return this.checked == 1;
  }

  @Override
    public void toggleState() {
    if (this.alwayson) {
      visible = true;
    } else {
      visible = !visible;
    }
  }

  public int getNumberOfChildren() {
    int numberofstyles = 0;

    for (Map.Entry<String, EMCCVStylegroup> entry : this.stylegroups.entrySet()) {
      numberofstyles += entry.getValue().styles.size();
    }

    return numberofstyles;
  }

  @Override
    public boolean isDisabled() {
    return super.isDisabled() || !this.getXMLParent().isActive();
  }

  @Override
    public void randomize() {
    for (Map.Entry<String, EMCCVStylegroup> entry : this.stylegroups.entrySet()) {
      boolean success = false;
      while (!success) {
        success = entry.getValue().randomize();
      }
    }
  }
}