public void resetButtonList() {
  // remove all Aspect and Style buttons from the list
  ArrayList<EMCCVButton> deleteList = new ArrayList<EMCCVButton>();
  for (EMCCVButton button : buttonList) {
    if (!(button.ELEMENT instanceof EMCCVSet)) {
      deleteList.add(button);
    }
  }
  for (EMCCVButton button : deleteList) {
    buttonList.remove(button);
  }
  deleteList.clear();
}

public void drawInfoTab() {
    int y = ASPECTMENU_Y;
    noTint();
    try {
      image(activeModule.logo, ASPECTMENU_X, y, 245, 60);
    } 
    catch (Exception e) {
      log.append(getTime() + "[ERROR] No Module logo found.");
    }

    StringBuilder sb = new StringBuilder("EMCCV Prototype " + EMCCV_VERSION + "\n");

    if (activeModule.id != null) {
      sb.append("activeModule id: ").append(activeModule.id + " v" + activeModule.version + "\n");
    }
    if (activeModule.authorid != null) {
      sb.append("author id: ").append(activeModule.authorid + "\n");
    }
    if (activeModule.sDesc != null) {
      sb.append("\n" + activeModule.sDesc);
    }
    if (randomKeys.size() > 0) {
      sb.append("\n\nRandomization shortcuts: \n");
      for (Map.Entry<String, EMCCVMenuElement> entry : randomKeys.entrySet()) {
        sb.append(entry.getKey() + ": ");
        sb.append(entry.getValue().title + "\n");
      }
    }
    textAlign(LEFT, TOP);
    fill(GUI_TEXT);
    text(sb.toString(), ASPECTMENU_X, y+60+MARGIN, 256, 500);
}