public static class EMCCVTool {
  
  // CONSTANTS
  static final int ICON_SIZE  = 32;
  static final int TOOLBAR_Y  = 60;
  static final int TOOLBAR_H  = ICON_SIZE + 4;
  static final int TOOLBAR_BG = 100;

  static final int ICON_ENABLED  = 128;
  static final int ICON_DISABLED = 50;
  static final int ICON_ACTIVE   = 255;
  static final int Y = (TOOLBAR_H - ICON_SIZE) / 2 + TOOLBAR_Y;

  // TOOL LIST
  static ArrayList<EMCCVTool> tools = new ArrayList<EMCCVTool>();

  // ATTRIBUTES
  final int X;
  final String title;
  final PImage ICON;
  boolean active;
  boolean disabled;

  // CONSTRUCTOR
  public EMCCVTool(final int X, String title, PImage ICON) {
    this.X = X;
    this.title = title;
    this.ICON = ICON;
    
    tools.add(this);
  }
  
  public boolean mouseOver(int x, int y) {
    if (x >= this.X && x <= this.X + ICON_SIZE && y >= Y && y <= Y + ICON_SIZE) {
      return true;
    } else {
      return false;
    }  
  }
  
  public int getColor() {
    if (this.disabled) {
      return ICON_DISABLED;
    } else if (this.active) {
      return ICON_ACTIVE;
    } else {
      return ICON_ENABLED;
    }
  }
}